// D' (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>

#include "d88.h"
#include <string.h>

unsigned char buff[0x100*17*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _offset + _size);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{

	unsigned char id1[] = "(a)SYSTEMX1 D'";
	unsigned char id2[] = "(b)SYSTEMX1 D'";
	unsigned char id3[] = "(c)SYSTEMX1 D'";
	char fname[11];
	int i,d;

	struct fpos ma1[] =
	{
		{ 0x0c, 0x0b, 0x1300 },
		{ 0x32, 0x01, 0x1e00 },
		{ 0x42, 0x01, 0x1300 },
		{ 0x43, 0x04, 0x1100 },
		{ 0x45, 0x01, 0x1000 },
		{ 0x46, 0x01, 0x0300 },
		{ 0x46, 0x04, 0x0500 },
		{ 0x46, 0x09, 0x0600 },
		{ 0x47, 0x01, 0x0500 },
		{ 0x47, 0x06, 0x0500 },
		{ 0x47, 0x0b, 0x0500 },
		{ 0x48, 0x01, 0x0400 },
		{ 0x48, 0x05, 0x0600 },
		{ 0x48, 0x0b, 0x0600 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};
	struct fpos mb1[] =
	{
		{ 0x0c, 0x01, 0x0a00 },
		{ 0x3a, 0x01, 0x0500 },
		{ 0x3a, 0x06, 0x0900 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};
	struct fpos ma2[] =
	{
		{ 0x43, 0x01, 0x0300 },
		{ 0x43, 0x04, 0x0500 },
		{ 0x43, 0x09, 0x0600 },
		{ 0x47, 0x01, 0x0500 },
		{ 0x47, 0x06, 0x0500 },
		{ 0x47, 0x0b, 0x0500 },
		{ 0x49, 0x05, 0x0600 },
		{ 0x49, 0x0b, 0x0600 },
		{ 0x4d, 0x01, 0x0400 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};
	struct fpos mb2[] =
	{
		{ 0x3b, 0x01, 0x0100 },
		{ 0x3b, 0x02, 0x0300 },
		{ 0x3b, 0x05, 0x0400 },
		{ 0x3b, 0x09, 0x0200 },
		{ 0x3b, 0x0b, 0x0300 },
		{ 0x3b, 0x0e, 0x0300 },
		{ 0x3d, 0x01, 0x0300 },
		{ 0x3d, 0x04, 0x0500 },
		{ 0x3d, 0x09, 0x0500 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	disk.SetRecordRange(0x01,0x010);
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x11, 0x01, buff, 0x100);
		if (!memcmp(buff,id1,sizeof(id1)-1))
		{
			printf("Disk A F܂.\n");
			fcut("OPMPRG", 0x09, 0x04, 0x01, 0x01, 0x01, 0x0000, 0x1c00);
			fcut("PSGPRG", 0x06, 0x03, 0x00, 0x01, 0x01, 0x0000, 0x1a00);
			for (i=0; ma1[i].sec; i++)
			{
				sprintf(fname,"MA0%02d",i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x01, 0x0000, ma1[i].size);
			}
			for (i=0; mb1[i].sec; i++)
			{
				sprintf(fname,"MB0%02d",i);
				fcut(fname, mb1[i].trk, mb1[i].trk>>1, mb1[i].trk&1, mb1[i].sec, 0x01, 0x0000, mb1[i].size);
			}
		}
		else if (!memcmp(buff,id2,sizeof(id2)-1))
		{
			printf("Disk B F܂.\n");
			for (i=0; ma2[i].sec; i++)
			{
				sprintf(fname,"MA1%02d",i);
				fcut(fname, ma2[i].trk, ma2[i].trk>>1, ma2[i].trk&1, ma2[i].sec, 0x01, 0x0000, ma2[i].size);
			}
			for (i=0; mb2[i].sec; i++)
			{
				sprintf(fname,"MB1%02d",i);
				fcut(fname, mb2[i].trk, mb2[i].trk>>1, mb2[i].trk&1, mb2[i].sec, 0x01, 0x0000, mb2[i].size);
			}
		}
		else if (!memcmp(buff,id3,sizeof(id3)-1))
		{
			printf("User Disk F܂.\n");
		}
	}
	return 0;
}

